 '  programme QuickBasic pour QB64
 '  Rsolution  sur le Rubik's Cube par Alain Renier anne 2012.
    ' - Fonctionne sous Windows XP. 
    '
    ' - On peut sauvegarder jusqu' 16 fichiers, de donnes des facettes
    ' - entres une  une. 
    ' ATTENTION !
    ' - Le programme ncessite un sous-dossier de Quickbasic (directory) nomm "RUBIK".
    ' -     dans ce dossier doivent tre implants les fichiers
    ' -     CUBDATA.RBK     et    TRANSIND.RBK et    CUB641AF.BAS.
    ' -     Si ces fichiers ne sont pas dans cette directory, le programme ne
    '        fonctionnera pas {arrt avec message !.}
    '   Egalement, les fichiers "RUBIK1.RBK  RUBIKX.RBK"  (X= numro d'ordre)
    '   s'ils existent, ce sont des sauvegardes d'exercices prcdents.
    ' - Si ces fichiers ne sont pas dans cette directory, le programme ne proposera pas
    '   la rcupration des donnes.
    '   Si QB64 est implant sur un disque diffrent:  
    ' - Modifier la ligne [ab$ = "D:\qb64\rubik"]
    ' - Les fichiers de sauvegarde sont nomms "RUBIK1.RBK   RUBIK16.RBK"
    ' - Quelques dtails sur les tableaux, de variables, utiliss:
    ' - cf%(i%,j%)    Tableau miroir contient la couleur de la facette
    ' - tf%(k%)        numro du cube devant occuper la position k
    ' - Configuration courante
    ' - C%(i%,j%)     Couleur de la facette i%,j%; et poids du cube lmentaire
    ' - t%(K%)         numro du cube occupant la position k
    ' - z%(K%)        position occupe par le cube k
    ' - co%(6)        Contient la couleur affecte par dfaut
    ' - vo%(6)        Suite du Poids binaire des valeurs 1, 2, 4, 8, 16 ou 32.
    ' - Couleurs du cube par dfaut
    ' - blanc = 1,    vert   = 2,    Rouge = 3,
    ' - bleu  = 4,    orange = 5,    jaune = 6 
    ' - P%  tableau de 9 positions, mais 6 seulement utilises pour le cube
    ' - Couleurs relles
    ' - P%(1)  (6) Contient la couleur relle pour l'cran (SCREEN 12 MS-DOS) dans l'ordre :
    ' - blanc  = 15,    vert  = 2,    Rouge  = 4,
    ' - bleu   = 9,    orange = 12,   Jaune  = 14
    ' - P%(7)  (9) pour utilisation dans le programme
    ' - cyan  = 11,    gris = 8, verlight    =    10
    ' - SS%(20)     somme des poids 2^x-1  des sommets et des artes
    ' - Initialisation
    ' - tableaux des rpertoires des mouvements (contenus dans CUBDATA.RBK)
    '     bf1$(112)    -->    donnes    "rf1$" :   affichage
    '     bc1$(112)    -->    donnes    "cm1$" :   excution
    '     bf2$(99)     -->    donnes    "rf2$" :   affichage
    '     bc2$(99)     -->    donnes    "cm2$" :   excution
    '     bf3$(27)     -->    donnes    "rf3$" :   affichage
    '     bc3$(27)     -->    donnes    "cm3$" :   excution
    ' - tableaux d'index:   (contenus dans TRASIND.RBK)
    '    id1% integer    -->    pointe sur les donnes de bf1$ et bc1$
    '    id2% integer    -->    pointe sur les donnes de bf2$ et bc2$
    '    id3% integer    -->    pointe sur les donnes de bf3$ et bc3$
    '    so%(54) integer -->    utilis pour calcul du coefficient K% dans [SUB calcv]
    '************************************************************************************************  
5
 ' tableaux communs utiliss par le programme
    COMMON SHARED C%(), cf%(), tf%(), t%(), z%(), w%(), vo%(), L%, K%, gm$, tem%, tconf%
    COMMON SHARED delier#, drl#, cdir$(), B%
    ' tableau des index d'appel des routines    test, testt1    
    TYPE bap
        tst1 AS INTEGER
        tst2 AS INTEGER
    END TYPE
    ' tableau des index d'appel des routines  testk1, testk2
    TYPE sap
        tsk1 AS INTEGER
        tsk2 AS INTEGER
        tsk3 AS INTEGER
        tsk4 AS INTEGER
    END TYPE
    ' Couleurs d'affichage
    TYPE nocol
        kol AS STRING * 6
    END TYPE
    ' Message  transmettre
    TYPE R
        Ms AS STRING * 8
    END TYPE
    ' dclaration des tableaux partags
    DIM SHARED C%(6, 9), cf%(6, 9), tf%(20), t%(20), z%(20)
    DIM SHARED s%(20), ss%(20), w%(32), co%(6), vo%(6)
    DIM SHARED tr$(4)
    DIM SHARED bf1$(112), bc1$(112), bf2$(99), bc2$(99), bf3$(27), bc3$(27)
    DIM SHARED id1%(18), id2%(18), id3%(6), so%(54), P%(10)
    ' Variables partages 
    DIM SHARED pmsa$, cdir$(16), bd%, V%, con$, kx1%, ky1%, kx2%, ky2%
    DIM SHARED rf1$, rf2$, rf3$, cm1$, cm2$, cm3$, scrn%, ea%, kfc
    DIM SHARED kfsn%, stat%, xtdir%, xtfich%, lign%, col%, cz%, la%, lb%
    DIM SHARED afli%, afcol%, spr%, facpp%
    DIM SHARED COIhdG$, COIhdD$, DCOte$, HOriD$, COIbdG$, COIbdD$
    DIM SHARED aptst(1 TO 78) AS bap
    DIM SHARED aptsk(1 TO 35) AS sap
    DIM SHARED nocou(8) AS nocol
    CONST angl   = 30, pi#    = 3.14159265357989#
    CONST TRUE   = -1, FALSE  = 0
    CONST bt%    = 1, bu%     = 2, bv% = 3, bw% = 4
    CONST nbfac% = 6, nfacet% = 9
    HOriD$  = CHR$(205)  ' 0CDh
    COIhdD$ = CHR$(187)  ' 0BBh
    COIhdG$ = CHR$(201)  ' 0C9h
    COIbdD$ = CHR$(188)  ' 0BCh
    COIbdG$ = CHR$(200)  ' 0C8h
    DCOte$  = CHR$(186)  ' 0BAh
    ' tableau pointeur pour dplacement dans les tableaux d'index
    DIM SHARED bl%(18)
    bl%(1)  =  0: bl%(2)  =  12:   bl%(3)  =  11:   bl%(4)  =  10
    bl%(5)  =  0: bl%(6)  =  8:    bl%(7)  =  7:    bl%(8)  =  7
    bl%(9)  =  9: bl%(10) =  8:    bl%(11) =  7:    bl%(12) =  6
    bl%(13) =  5: bl%(14) =  4:    bl%(15) =  3:    bl%(16) =  5
    bl%(17) =  4: bl%(18) =  3
    ' Couleurs par dfaut
    blanc%  = 15: vert%   = 2:  rouge% = 4
    bleu%   = 9:  orange% = 12: jaune% = 14
    gris%   = 8:  verlig% = 10: cyan%  = 11
    rougeL% = 13
    ' tableau P% reoit les lments de couleur
    P%(1) = blanc%    '(face 1)
    P%(2) = vert%     '(face 2)
    P%(3) = rouge%    '(face 3)
    P%(4) = bleu%     '(face 4)
    P%(5) = orange%   '(face 5)
    P%(6) = jaune%    '(face 6)
    P%(7) = cyan%     '(affichage)
    P%(8) = gris%     '(neutre)
    P%(9) = verlig%   '(affichage)
    P%(10)    = rougeL%
    nocou(1).kol = "BLANC "
    nocou(2).kol = "VERT  "
    nocou(3).kol = "ROUGE "
    nocou(4).kol = "BLEU  "
    nocou(5).kol = "ORANGE"
    nocou(6).kol = "JAUNE "
    con$ = " < une touche pour continuer >"
    afli% = 9: Afcol% = 42
    de% = FALSE
    ' Dans le cas possible d'une erreur
    ON ERROR GOTO traiterreur
    _TITLE "*** CHOIX DE LA RESOLUTION D'ECRAN. ***"
    LOCATE 10, 2
    COLOR p%(7)
    PRINT " Choisissez le mode d'cran "
    PRINT "      1 = 640 x 480 mode 12 "
    PRINT "      2 = 800 x 600 256   "
    LOCATE CSRLIN, 2
    DO
        INPUT " <1> ou <2> "; scrn%
    LOOP UNTIL scrn% = 1 OR scrn% = 2
    IF scrn% = 1 THEN
        a& = _NEWIMAGE(640, 480, 12)
        SCREEN a&
        _SOURCE a&
        _DEST a&
        WIDTH 80, 60
        Kx1% = 186: Ky1% = 150
        Kx2% = 480: Ky2% = Ky1%     '
        la% = 48: cz% = 79
        lb% = 51: kfc = 1: spr% = 2
    ELSE
        b& = _NEWIMAGE(800, 600, 256)
        SCREEN b&
        _SOURCE b&
        _DEST b&
        TTFont$ = "LUCON":height& = 12:style$ = "Monospace, BOLD"
        fnt& = _LOADFONT("C:\Windows\Fonts\" + TTFont$ + ".ttf", height&, style$)
        _FONT fnt&, b&
        Kx1% = 206: Ky1% = 194
        Kx2% = 540: Ky2% = Ky1%
        la% = 38: cz% = 88
        lb% = 41: kfc = 800/640: spr% = 3
    END IF
    _TITLE "*** RUBIK'S CUBE POUR QB64. ***"
    _SCREENHIDE          ' cacher les mouvements d'cran
    _SCREENMOVE _MIDDLE  ' centrer l'cran
    _SCREENSHOW
    ab$ = "D:\qb64\rubik"
    IF _DIREXISTS(ab$) THEN
        CHDIR ab$
        xtdir% = TRUE
    ELSE
        ERROR 76
    END IF
    facpp% = FALSE
    ' delta temps = .1 s
    drl# = .1
    ' coefficient sinus x ( en degr)
    Kfsn% = (CINT(angl * (SIN(angl * (pi# / 180)))))  '  sin30 = 1/2 donc Kfsn% = 15
    ab$ = "cubdataf.rbk"
    IF _FILEEXISTS(ab$) THEN
        fich% = FREEFILE
        OPEN ab$ FOR INPUT AS #fich%
        'initialiser les tableaux  de donnes bf1$ et bc1$
        Tablo 224, fich%, bf1$(), bc1$()
        'initialiser les tableaux  de donnes bf2$ et bc2$
        Tablo 198, fich%, bf2$(), bc2$()
        'initialiser les tableaux  de donnes bf3$ et bc3$
        Tablo 54, fich%, bf3$(), bc3$()
        CLOSE #fich%
    ELSE
        ERROR 53
    END IF
    ab$ = "transind.rbk"
    IF _FILEEXISTS(ab$) THEN
        fich% = FREEFILE
        OPEN ab$ FOR BINARY AS #fich%
        'initialiser les tableaux d'index
        Tablau 36, fich%, id1%(), id2%()
        Tablax 6, fich%, id3%()
        'initialiser le tableau de sauts
        Tablax 54, fich%, so%()
        'initialiser les tableaux d'appels test, testT1
        Tablat 78, fich%, aptst(), aptsk(), 1
        'initialiser les tableaux d'appels testK1, testK2
        Tablat 35, fich%, aptst(), aptsk(), 2
        ' initialiser tableau des ensembles sommets (8) et artes(12)
        Tablax 20, fich%, ss%()
        CLOSE #fich%
    ELSE
        ERROR 53
    END IF
    FOR i% = 1 TO nbfac%
        ' couleur virtuelle des faces
        co%(i%) = i%
        ' valeur (poids des facettes) vo%(x) = 1, 2, 4, 8, 16 ou 32
        vo%(i%) = 2 ^ (i% - 1)
        ' w%(x) contient la couleur point par la valeur du poids de la facette.
        w%(vo%(i%)) = i%
    NEXT i%
    ' Au dpart, le tableau, des fichiers est  vide. 
    FOR i% = 1 TO UBOUND(cdir$)
        cdir$(i%) = ""
    NEXT i%
    'Initialisation gnrale.
    failinit 2
    tconf% = 0
'    xtdir% = FALSE
    xtfich% = FALSE
    ' pour obtenir seulement les rpertoires.
    attr1$ = "/A:D/B"
    ' <dir.rep> pour contenir les rpertoires.
    attr2$ = "dir.rep"
    ' nom de rpertoire et/ou de fichier par dfaut
    attr3$ = "rubik"
    collect attr1$, attr2$, attr3$, cdir$()
    ' pour obtenir uniquement les noms de fichiers, extension .rbk par dfaut
    attr1$ = "*.rbk /B"
    '  placer dans fichier <dir.txt>
    attr2$ = "dir.txt"
    ' rubik = nom gnrique par dfaut, attr3$ = "rubik"
    collect attr1$, attr2$, attr3$, cdir$()
    IF xtfich% THEN    ' = TRUE 
        ' chercher la borne suprieure du nombre de fichiers
        FOR i% = 1 TO UBOUND(cdir$)
            IF cdir$(i%) <> "" THEN
                mind% = i%
            ELSEIF cdir$(i%) = "" THEN
                EXIT FOR
            END IF
        NEXT i%
        Tri cdir$()
    END IF
    full = _FULLSCREEN
    IF full = 0 THEN
        _FULLSCREEN
    END IF
    DO
        q$ = " FINALE "
        hf% = mconfig%(q$)
        ' attente  HF = 1  Cube normal, ou    HF = 2  Rotation des faces
        ' Cas 1, cube normal
        failinit 1
        failinit 2
        efface 0, 0, 0
        q$ = " INITIALE "
        hi% = mconfig%(q$)
        IF (hf% = 1) AND (hi% = 1) THEN
            LOCATE 6, 2
            PRINT " *** Vous ne pouvez pas avoir une configuration INITIALE = Cube normal ***"
            LOCATE 7, 14: PRINT " *** et une configuration FINALE = Cube normal !  ***"
            LOCATE 8, 14: PRINT " ***** Auquel cas, le logiciel ne set  rien !  ****"
            LOCATE 9, 14
            PRINT " *********   Recommencez  votre selection S.V.P. ********* "
            delier# = 4:delay
            ' effacer les messages
            efface 0, 0, 0
        ELSEIF    (hf% = 2 AND hi% = 2) OR (hf% = 1 AND hi% = 2)_
            OR    (hf% = 1 AND hi% = 3) OR (hf% = 2 AND hi% = 3) THEN
            EXIT DO
        END IF
    LOOP
    ' Rotation des faces
    IF (hi% = 2) AND (hf% = 1) THEN
        movself 1
        Affect
        tconf% = 1
    ELSEIF (hi% = 2) AND (hf% = 2) THEN
        movself 0
        LOCATE la%, 2: PRINT " Voulez-vous un autre exercice?   <O>ui     <N>on";
        DO UNTIL nc$ = "O" OR nc$ = "N"
            nc$ = UCASE$(INKEY$)
        LOOP
        IF nc$ = "O" THEN
            CLS
            LOCATE 10, 10: PRINT " Attendez un moment S.V.P. "
            full = _FULLSCREEN
            IF full > 0 THEN
                _FULLSCREEN _OFF
            END IF
            SLEEP 2
            SCREEN 0
            CLEAR
            RUN 5
        END IF
        SYSTEM
    ELSEIF (hi% = 3) AND (hf% = 2) THEN
        ' ne rien faire
    END IF
    IF hi% = 3 THEN
        Affcadr 12
        ' Si fichier(s) existe(nt)
        IF xtfich% THEN
            COLOR P%(7): LOCATE 4, 2
            FOR i% = 1 TO 6
                PRINT STRING$(50, " ")
                LOCATE CSRLIN, 2
            NEXT i%
            LOCATE 4, 4: PRINT " Rcuprer les donnes ?  <O / N> ";
            LOCATE la%, 4: PRINT " Pour entrer les couleurs des facettes, rpondre Non "
            PRINT con$
            SLEEP
            effa52
            PRINT STRING$(cz% - 1, " ")
            LOCATE 4, 36: psa$ = req$(psa$, "O", "N")
        END IF
        IF hf% = 1 THEN
            LOCATE 6, 4: PRINT " fonctionnement pas  pas ? <O / N> ";
            loq% = CSRLIN: posa% = POS(0) 
            LOCATE la%, 2: PRINT " Utilisez le mode PAS  PAS si vous avez un RUBIK'S CUBE "
            LOCATE CSRLIN, 2: PRINT "  et si vous souhaitez le rsoudre. "
            PRINT con$
            SLEEP
            efface 1, la%, la% + 2
            LOCATE loq%, posa%
            pmsa$ = req$(pmsa$, "O", "N")
        END IF
        LOCATE 4, 4: PRINT STRING$(40, " ")
        LOCATE 6, 4: PRINT STRING$(40, " ")
        IF (psa$ = "O") AND (xtfich%) THEN
            ' afficher les fichiers
            IF mind% <> 0 THEN Affichier mind%, cdir$()
            LOCATE CSRLIN + 2, 4: PRINT "Quel Fichier ? de 1  " + STR$(mind%) + "  ";
            COLOR P%(1)
            i% = 0
            DO UNTIL (i% > 0) AND (i% <= mind%) 
                INPUT ;"",i%
            LOOP
            LOCATE la%, 2
            PRINT con$
            SLEEP
            effa52
            COLOR P%(7)
            nomfic$ = cdir$(i%)
            nfich% = FREEFILE
            OPEN nomfic$ FOR BINARY AS nfich%
            LirEcrir nfich%, C%(), 1
            CLOSE #nfich%
            IF pmsa$ = "O" THEN
                regles
            END IF
            COLOR P%(1)
            Affect
            tconf% = 2
        ELSE
            CLS
            dkolfac
            tconf% = 1
            facpp% = TRUE
        END IF
    END IF
    IF (tconf% = 1 AND facpp%) OR (tconf% = 1 AND stats% > 0) THEN
    '    CLS
        efface 1, 1, 14
        Affcadr 10 
        LOCATE 4, 4: PRINT " Sauvegarder les donnes <O / N> ";
        sa$ = req$(sa$, "O", "N")
        IF sa$ = "O" THEN
            nfich% = FREEFILE
            LOCATE 5, 4
            IF xtfich% = FALSE THEN
                cfichier mind%, mname$
                OPEN mname$ FOR BINARY AS nfich%
            ELSEIF mind% < UBOUND(cdir$) THEN
                cfichier mind%, mname$
                OPEN mname$ FOR BINARY AS nfich%
            ELSEIF mind% = UBOUND(cdir$) THEN
                PRINT "Le maximum de fichiers existe dj! "
                LOCATE CSRLIN, 4: PRINT "en remplacer un ? <O> ou <N>"
                sa1$ = req$(sa1$, "O", "N")'                
                LOCATE 5, 4 : PRINT STRING$(50," ")
                LOCATE 6, 4 : PRINT STRING$(50," ")
                'CLS
                IF sa1$ = "N" THEN
                    LOCATE 5, 4: PRINT " Fichier non sauvegard ";
                    PRINT " Limite atteinte. (limite = ";UBOUND(cdir$)
                ELSE
                    Affichier mind%, cdir$()
                    PRINT " Quel fichier ? " ;
                    rng% = VAL(INPUT$(2))
                    mname$ = cdir$(rng%)
                    OPEN mname$ FOR BINARY AS nfich%
                END IF
            END IF
            LirEcrir nfich%, C%(), 2
            CLOSE #nfich%
            LOCATE CSRLIN, 4: PRINT " Fichier ";mname$, " enregistr!" 
        ELSE
            ta% = 11
            LOCATE 3, 1: PRINT COIbdG$ + STRING$(cz% - 2, HOriD$) + COIbdD$
            efface 1, 4, ta%
        END IF
        IF facpp% THEN facpp% = FALSE
    END IF
    IF hi% = 3 AND hf% = 2 THEN
        movself 0
        LOCATE la%, 2: PRINT " Voulez-vous un autre exercice?   <O>ui     <N>on";
        DO UNTIL nc$ = "O" OR nc$ = "N"
            nc$ = UCASE$(INKEY$)
        LOOP
        IF nc$ = "O" THEN
            CLS
            LOCATE 10, 10: PRINT " Attendez un moment S.V.P. "
            full = _FULLSCREEN
            IF full > 0 THEN
                _FULLSCREEN _OFF
            END IF
            SLEEP 2
            SCREEN 0
            CLEAR
            RUN 5
        END IF
        SYSTEM
    END IF    
    '******** RECONSTITUTION DU CUBE ********
    COLOR P%(1)
    LOCATE la%, 2
    PRINT con$
    SLEEP
    effa52
    efface 1, 1, 14
    Affcadr 2
    ba$ = "Reconstitution du cube"
    COLOR P%(1)
    LOCATE 4, ((cz% - 1) - INT(LEN(ba$) + 2)) / 2: PRINT STRING$(24, "*")
    LOCATE CSRLIN, (cz% - INT(LEN(ba$))) / 2: PRINT ba$
    LOCATE CSRLIN, ((cz% - 1) - INT(LEN(ba$) + 2)) / 2: PRINT STRING$(24, "*")
    ' identificateur de progression dans la boucle principale.
    B% = 0
    'variable de dplacement de Saut so%()
    dx% = 1
    DO    ' Boucle principale
        IF pmsa$ = "N" THEN
            COLOR P%(9)
            LOCATE la%, 2: PRINT "Pour stopper, Appuyez sur T ";
            PRINT "puis appuyer sur <entrer>  pour reprendre";
            COLOR P%(1)
        END IF
        LOCATE la% + 1, 2: PRINT "Si  signe + =  Sens de la montre "
        LOCATE CSRLIN, 2: PRINT "SI  signe - =  Sens contraire ";
        'calcul de B%, K%, V%
        calcv B%, K%, V%, so%(dx%), so%(dx% + 1), so%(dx% + 2)
        ' affichage  l'cran
        posit B%, K%, V%
        'progression de 3 positions
        dx% = dx% + 3
        ta$ = UCASE$(INKEY$)
        IF ta$ = "Q" THEN
            lign% = CSRLIN :col% = POS(0)
            LOCATE lb%, 5: PRINT "Voulez vous quitter ?  touche <Q> ou <N> pour continuer"
            delier# = 4:delay
            effa52
            LOCATE lb%, 5: PRINT "Confirmez SVP  <Q>uite ou <N>on "
            ta$ = req$(ta$, "Q", "N")
            effa52
            IF ta$ = "Q" THEN
                EXIT DO
            ELSE
                effa52
                LOCATE lign%, col%
            END IF
        END IF
        SELECT CASE B%
            ' cas 1  4 , et 9  14   appel   test  et  testT1
            CASE 1 TO 4, 9 TO 14
                ' 2 paramtres sont ncessaires
                atrib 0, 13, 1, 13, 1, 0, q0%, q1%, 0, 0, 0
                ' cas K% = 1
                IF K% = 1 THEN
                    test q0%, q1%, V%, rf1$, cm1$
                ' cas K% de 2  12
                ELSEIF (K% > 1) AND (K% < 13) THEN
                    testT1 q0%, q1%, V%, rf1$, rf2$, cm1$, cm2$
                END IF
            '  cas 5  8 , et 16, 17  font appel  testK1 et testK2
            CASE 5 TO 8, 16, 17
                ' 4 paramtres sont ncessaires
                atrib 0, 9, 0, 9, 0, 0, q0%, q1%, q2%, q3%, 1
                IF B% < 9 THEN mg% = id3%(B% - 4) + K% - 1
                IF B% = 16 OR B% = 17 THEN mg% = id3%(B% - 11) + K% - 1
                rf3$ = bf3$(mg%)
                cm3$ = bc3$(mg%)
                ' cas K% = 1
                IF K% = 1 THEN
                    testK1 q0%, q1%, q2%, q3%, V%, rf1$, rf2$, cm1$, cm2$
                ' cas K% de 2  8
                ELSEIF (K% > 1) AND (K% < 9) THEN
                    testK2 q0%, q1%, q2%, q3%, V%, rf1$, rf2$, rf3$, cm1$, cm2$, cm3$
                END IF
            ' cas 15 spcial. fait appel 2 fois  test si K% = 2
            CASE 15
                ' cas K% = 1 et K% = 2
                atrib 0, 3, 0, 0, 0, 0, q0%, q1%, 0, 0, 0
                    test q0%, q1%, V%, rf1$, cm1$
                ' cas K% = 2
                IF K% = 2 THEN
                    LOCATE afli%, Afcol%
                    atrib 0, 3, 0, 0, 0, 1, q0%, q1%, 0, 0, 0
                    test q0%, q1%, V%, rf1$, cm1$
                END IF
            CASE 18
                ' cas K% = 1
                atrib 0, 2, 0, 2, 0, 0, q0%, q1%, q2%, q3%, 1
                IF K% = 1 THEN
                    testK1 q0%, q1%, q2%, q3%, V%, rf1$, rf2$, cm1$, cm2$
                ELSE
                    ' si B% = 18 et K% = 2, position non rsolue
                    IF de% = FALSE THEN
                        effa52
                        LOCATE la% + 1, 1: PRINT STRING$(40, " ")
                        LOCATE la% + 2, 1: PRINT STRING$(40, " ");
                        LOCATE la% , 2: PRINT "POSITION non rsolue.  Deuxime passage... "
                        de% = TRUE
                        PRINT con$
                        SLEEP
                        affect
                        B% = 0
                        dx% = 1
                    ELSE
                        LOCATE la% + 2: PRINT "POSITION IMPOSSIBLE."
                    END IF
                END IF
        END SELECT
        ' si B% = 18  c'est fini !
    LOOP UNTIL B% = 18
    IF pmsa$ = "N" THEN
        LOCATE 5, 50: PRINT STRING$(30, " ")
        LOCATE 6, 50: PRINT STRING$(30, " ")
        effa52
        PRINT STRING$(50, " ");
    END IF
    LOCATE la% + 1, 1: PRINT STRING$(40, " ")
    LOCATE la% + 2, 1: PRINT STRING$(40, " ");
    LOCATE la%, 2: PRINT " " + STR$(stat%) + " mouvements effectus! " + "  < une touche pour finir >"
    SLEEP
    effa52
    PRINT " Voulez-vous un autre exercice?   <O>ui     <N>on";
    DO UNTIL nc$ = "O" OR nc$ = "N"
        nc$ = UCASE$(INKEY$)
    LOOP
    IF nc$ = "O" THEN
        CLS
        LOCATE 10, 10: PRINT " Attendez un moment S.V.P. "
        full = _FULLSCREEN
        IF full > 0 THEN
            _FULLSCREEN _OFF
        END IF
        SLEEP 2
        SCREEN 0
        CLEAR
        RUN 5
    END IF
    SYSTEM
traiterreur:
    lg% = CSRLIN:pg% = POS(0)
    SELECT CASE ERR
        CASE 5
            LOCATE lb%, 2
            PRINT "** Appel de fonction interdit - Erreur " + STR$(ERR)
            PRINT " Erreur a la ligne " + STR$(_ERRORLINE)
            PRINT con$
            SLEEP
            aaerre% = aaerre% + 1
            aerr aaerre%
        CASE 6
            LOCATE lb%, 2
            PRINT "** Dpassement de capacit - Erreur " + STR$(ERR)
            PRINT " Erreur a la ligne " + STR$(_ERRORLINE)
            PRINT con$
            SLEEP
            bberre% = bberre% + 1
            aerr bberre%
        CASE 7
            CLS
            LOCATE lb% - 6, 2
            PRINT "** Mmoire Insuffisante - Erreur " + STR$(ERR)
            PRINT "   Arrt du programme  Corrigez le dfaut si possible "
            PRINT "   et relancez le programme !  "
            PRINT "<Une touche pour finir..>"
            SLEEP
            SYSTEM
        CASE 9
            LOCATE lb%, 2
            PRINT "** Indice en dehors des limites - Erreur " + STR$(ERR)
            PRINT " Erreur a la ligne " + STR$(_ERRORLINE)
            PRINT con$
            SLEEP
            cerre% = cerre% + 1
            aerr cerre%
        CASE 52, 64
            LOCATE lb%, 2
            PRINT "** Nom ou Num. de fichier incorrect - Erreur " + STR$(ERR)
            PRINT " Erreur a la ligne " + STR$(_ERRORLINE)
            PRINT con$
            SLEEP
            perre% = perre% + 1
            aerr perre%
        CASE 71
            LOCATE lb%, 2
            PRINT "** Disque non prt - Erreur " + STR$(ERR)
            PRINT " Erreur a la ligne " + STR$(_ERRORLINE)
            PRINT con$
            SLEEP
            derre% = derre% + 1
            aerr derre%
        CASE 53, 76:    
            CLS
            LOCATE lb% - 6, 2
            PRINT "** Fichier ou chemin d'accs introuvable - ERREUR " + STR$(ERR)
            PRINT " Le programme ne trouve pas les fichiers cubdata.rbk "
            PRINT "  et/ou transind.rbk qui sont indispensables. "
            PRINT "  Fin du programme ! rectifiez, et relancez le programme."
            PRINT " Erreur a la ligne " + STR$(_ERRORLINE)
            PRINT "<Une touche pour finir..>"
            SLEEP
            CLS
            SYSTEM 
        CASE 258
            LOCATE lb%, 2
            PRINT "** Mauvais handle - ERREUR " + STR$(ERR)
            PRINT " Erreur a la ligne " + STR$(_ERRORLINE)
            INPUT " Continuer quand mme <O>  <N> "; thx$
            IF UCASE$(thx$) = "N" THEN SYSTEM
        CASE ELSE
            LOCATE lb%, 2
            PRINT "** Erreur " + STR$(ERR)
            '  assignez un 'label',  si doute d'un risque d'erreur
            '  l'endroit   identifier du programme
            IF ERL <> 0 THEN PRINT "Erreur  la ligne label " + STR$(ERL)
            PRINT "Erreur  la ligne " + STR$(_ERRORLINE)
    END SELECT
    efface 1, lb%, lb% + 6
    LOCATE lg%, pg%
    RESUME NEXT
    '  **** fin de CUB641BF.bas (principal)****
 '********************************************************************
SUB Aerr (nerna%)
    IF nerna% > 10 THEN
        LOCATE lb% + 3, 2: PRINT "Trop d'erreurs"
        PRINT "rectifiez si possible et recommencez!"
        PRINT "<Une touche pour finir..>"
        SLEEP
        SYSTEM
    END IF
END SUB
 '********************************************************************
SUB cfichier (pa%, mn$)
 ' cration de fichier
 '********************************************************************
        pa% = pa% + 1
        PRINT "un fichier Rubik" + LTRIM$(STR$(pa%));".RBK va tre cr "
        mn$ = "RUBIK" + LTRIM$(STR$(pa%)) + ".RBK"
END SUB
 '********************************************************************
SUB Affichier (pb%, md$())
 ' afficher les fichiers
 '********************************************************************
    LOCATE 4, 3: PRINT "Fichiers disponnibles :"
    LOCATE 5, 3
    xu% = 0
    FOR i% = 1 TO pb%
        xu% = xu% + 1
        IF LEN(md$(i%)) = 10 THEN
            COLOR p%(9)
            PRINT STR$(i%) + ". ";
            COLOR p%(7)
            PRINT md$(i%);" ";
        ELSE
            PRINT i%; md$(i%) ;
        END IF
        IF xu% = 5 THEN
            PRINT: LOCATE CSRLIN, 3
            xu% = 0
        END IF
    NEXT i%    
END SUB
 '********************************************************************
SUB Affcadr (ap%)
 ' Affiche un cadre sur l'cran
 '********************************************************************
    COLOR P%(7)
    bc$ = "* * * * R U B I K ' S   C U B E * * * *"
    boiteds 1, 1, cz% - 2, ap%
    LOCATE 2, ((cz% - 1) - INT(LEN(bc$))) / 2
    PRINT bc$
END SUB
 '********************************************************************
SUB Affcol
 ' entre: nant
 ' sortie: affichage  l'cran des couleurs des faces
 '********************************************************************
    ' --- Aide aux couleurs des faces
    LOCATE 1, 2
    FOR t% = 1 TO nbfac%
        COLOR P%(t%)
        IF t% = 1 THEN
            PRINT nocou(co%(t%)).kol;" : "; co%(t%);
        ELSEIF t% = 3 OR t% = 5 THEN
            PRINT " ";nocou(co%(t%)).kol;" : "; co%(t%);
        ELSE
            LOCATE CSRLIN, POS(0) + 1
            PRINT nocou(co%(t%)).kol;" : "; co%(t%)
        END IF
    NEXT t%
    COLOR P%(1)
    PRINT
END SUB
 '********************************************************************
SUB Affect
 ' affecte les donnes sur tableau de 20 positions
 '                soit 8 sommets de 3 facettes
 '                et  12 artes de 2 facettes.
 ' en  entre:    tableaux communs     s%(),  C%()
 ' sortie:        tableau  s%() ,
 '                tableau  C(i%, j%)
 '                affects et contrle de validit des donnes
 '********************************************************************
    FOR i% = 1 TO nbfac%
        FOR j% = 1 TO nfacet%
        ' remplace la valeur de C%(i, j) par le poids 2^(x-1)
            C%(i%, j%) = vo%(C%(i%, j%))
        NEXT j%
    NEXT i%
'    CLS
    ' ---- Reprage des petits cubes ----
    ' **Sommets**
    ' Par exemple, s%(1) = C%(face1, cube 7) + C%(face2, cube 3) + C%(face3, cube 1)
    s%(1)  = C%(1, 7) + C%(2, 3) + C%(3, 1)    ' somme poids 2^x coin haut avant gauche
    s%(2)  = C%(1, 1) + C%(2, 1) + C%(5, 3)    ' somme poids 2^x coin haut arrire gauche
    s%(3)  = C%(1, 3) + C%(4, 3) + C%(5, 1)    ' somme poids 2^x coin haut arrire droit
    s%(4)  = C%(1, 9) + C%(3, 3) + C%(4, 1)    ' somme poids 2^x coin haut avant droit
    s%(5)  = C%(2, 9) + C%(3, 7) + C%(6, 1)    ' somme poids 2^x coin bas avant gauche
    s%(6)  = C%(2, 7) + C%(5, 9) + C%(6, 7)    ' somme poids 2^x coin bas arrire gauche
    s%(7)  = C%(4, 9) + C%(5, 7) + C%(6, 9)    ' somme poids 2^x coin bas arrire droit
    s%(8)  = C%(3, 9) + C%(4, 7) + C%(6, 3)    ' somme poids 2^x coin bas avant droit
    ' **artes**
    s%(9)  = C%(1, 4) + C%(2, 2)            ' somme poids 2^x arte suprieure gauche
    s%(10) = C%(1, 2) + C%(5, 2)            ' somme poids 2^x arte suprieure arrire
    s%(11) = C%(1, 6) + C%(4, 2)            ' somme poids 2^x arte suprieure droite
    s%(12) = C%(1, 8) + C%(3, 2)            ' somme poids 2^x arte suprieure avant
    s%(13) = C%(2, 6) + C%(3, 4)            ' somme poids 2^x arte mdium avant gauche
    s%(14) = C%(2, 4) + C%(5, 6)            ' somme poids 2^x arte mdium arrire gauche
    s%(15) = C%(4, 6) + C%(5, 4)            ' somme poids 2^x arte mdium arrire droite
    s%(16) = C%(3, 6) + C%(4, 4)            ' somme poids 2^x arte mdium avant droite
    s%(17) = C%(2, 8) + C%(6, 4)            ' somme poids 2^x arte infrieure gauche
    s%(18) = C%(5, 8) + C%(6, 8)            ' somme poids 2^x arte infrieure arrire
    s%(19) = C%(4, 8) + C%(6, 6)            ' somme poids 2^x arte infrieure droite
    s%(20) = C%(3, 8) + C%(6, 2)            ' somme poids 2^x arte infrieure avant
    ' contrle
    FOR i% = 1 TO 20
        IF (s%(i%) > 56) AND (i% <= 20) THEN
            PRINT " Donnes Impossibles "
            EXIT FOR
        END IF
        FOR pt% = 1 TO 20
            IF ss%(pt%) = s%(i%) THEN
                t%(i%) = pt%  ' position occup par le  cube
                EXIT FOR
            END IF
        NEXT pt%
        z%(t%(i%)) = i%    ' position que doit occuper le  cube
    NEXT i%
    IF i% = 21 THEN
        tem% = 1
        initC 3
        Affcub L%, gm$, tem%
        ' si pm% <> 21, les donnes sont fausses !
    ELSEIF i% <> 21 THEN
        PRINT "Les donnes sont fausses! Erreur fatale -- arrt du programme"
        SLEEP
        SYSTEM
    END IF
END SUB
 '***********************************************************************
SUB Affcub (li%, gm$, clm%) STATIC
 ' AVERTISSEMENT :  ne pas modifier l'ordre des faces sans tre sur de ce que l'on fait !
 ' Cet ordre affecte directement l'affichage et les facettes par rapport aux tableaux!
 ' entre: Li% = N facette    gm$ = commande  excuter     clm% = tem%
 ' sortie: dessin du cube sur cran; fait appel  SUB traceface(...)
 '********************************************************************
    IF pmsa$ = "O" AND ea% AND clm% = 1 THEN
        Lign% = Csrlin: col% =  POS(0)
        LOCATE la%, 5: PRINT "< une touche pour continuer >"
        SLEEP
        LOCATE la%, 2: PRINT STRING$(40, " ")
        LOCATE Lign%, col%
    ELSE
        delier# = .3: delay
        ea% = TRUE
    END IF
     ' ----- Routine d'affichage graphique
    ' face 1, 3, 4, 2, 5, 6
    traceface 1, 3, 4, 2, 5, 6
    ' conserver la position ligne et colonne (texte) de l'cran
    lign% = Csrlin: col% =  POS(0) + 1
    IF scrn% = 1 THEN
        LOCATE 17, 23: PRINT "Face 1"
        LOCATE 31, 7: PRINT "Face 3" 
        LOCATE 26, 35: PRINT "Face 4"
        LOCATE 17, 60: PRINT "Face 2"
        LOCATE 31, 43: PRINT "Face 5"
        LOCATE 40, 54: PRINT "Face 6"
    ELSE
        LOCATE 15, 23: PRINT "Face 1"
        LOCATE 27, 5: PRINT "Face 3" 
        LOCATE 23, 34: PRINT "Face 4"
        LOCATE 15, 60: PRINT "Face 2"
        LOCATE 26, 42: PRINT "Face 5"
        LOCATE 34, 55: PRINT "Face 6"
    END IF
    ' rcuprer ligne et colonne
    IF col% > 80 then col% = 3
    LOCATE lign%, col%
    IF clm% = 1 THEN
        helpmov li%, gm$
        lign% = CSRLIN: col% = POS(0)
        IF pmsa$ = "O" THEN
        '    LOCATE la%, 5: PRINT con$
            wl$ = UCASE$(INPUT$(1))
            effa52
            IF wl$ = "Q" THEN END
        ELSE
            ' n'est utile que si pas  pas = non
            wc$ = UCASE$(INKEY$)
            IF wc$ = "T" THEN
                SLEEP
            END IF
            delier# = .110 + drl#:delay
        END IF
        LOCATE lign%, col%
    END IF
END SUB
 '***********************************************************************
SUB atrib (e1%, e2%, e3%, e4%, e5%, e6%, e7%, e8%, e9%, e10%, e11%)
 ' attribuer les affichage et commandes
 ' K%  contrler --> e1%, e2%     et     e3%, e4%
 ' e5% = repre pour "K% - 1"
 ' e6% = repre pour "K% + 1"
 ' SI e11% = 0      THEN    e7% = q0%, e8% = q1% 
 ' SI e11% = 1      THEN    e7% = q0%, e8% = q1%, e9% = q2%, e10% = q3% 
 '***********************************************************************
    k1% = k% + 1: k2% = k% - 1
    IF (K% > e1%) AND (K% < e2%) AND (e6% = 0) THEN mn% = id1%(B%) + K%
    IF (K% > e1%) AND (K% < e2%) AND (e6% = 1) THEN mn% = id1%(B%) + K1%
        rf1$ = bf1$(mn%)
        cm1$ = bc1$(mn%) 
        IF (K% > e3%) AND (K% < e4%) AND (e5% = 0) THEN mm% = id2%(B%) + K%
        IF (K% > e3%) AND (K% < e4%) AND (e5% = 1) THEN mm% = id2%(B%) + K2%
        rf2$ = bf2$(mm%)
        cm2$ = bc2$(mm%)
    ' calcul les paramtres  transmettre
    IF e6% = 0 THEN jf% = (calkoef%(bl%(), B%)) + K%
    IF e6% = 1 THEN jf% = (calkoef%(bl%(), B%)) + K1%
    IF e11% = 0 THEN e7% = aptst(jf%).tst1: e8% = aptst(jf%).tst2
    IF e11% = 1 THEN e7% = aptsk(jf%).tsk1: e8% = aptsk(jf%).tsk2: e9% = aptsk(jf%).tsk3: e10% = aptsk(jf%).tsk4
END SUB
 '***********************************************************************
SUB boiteds (ligx%, coly%, lng%, fin%) STATIC
 ' Trace un cadre double ligne sur l'cran
 '  En entre :       ligx% = ligne dbut
 '                    coly% = colonne dbut
 '                    lng% = largeur du cadre
 '                    fin% =  fin du cadre
 ' Sortie :           Affichage du cadre sur cran
 '**********************************************************************
    LOCATE ligx%, coly%: PRINT COIhdG$ + STRING$(lng%, HOriD$) + COIhdD$
    DO
        ligx% = ligx% + 1
        LOCATE ligx%, coly%: PRINT DCOte$ + STRING$(lng%, " ") + DCOte$
    LOOP UNTIL ligx% = fin%
    PRINT COIbdG$ + STRING$(lng%, HOriD$) + COIbdD$
END SUB
 '********************************************************************
SUB efface (bde%, ew%, ey%)
 ' effacer certaines lignes de l'cran
 '********************************************************************
    IF bde% = 0 THEN
        LOCATE 4, 3: PRINT STRING$(54, " ")
        LOCATE 6, 3: PRINT STRING$(74, " ")
        LOCATE 7, 3: PRINT STRING$(74, " ")
        LOCATE 8, 3: PRINT STRING$(54, " ")
        LOCATE 9, 3: PRINT STRING$(56, " ")
        LOCATE 12, 14: PRINT STRING$(60, " ")
    ELSE
        FOR ez% = ew% TO ey%
            LOCATE ez%, 1
            PRINT STRING$(cz%, " ")
        NEXT ez%
    END IF
END SUB
 '********************************************************************
SUB effa52
 ' efface la ligne 48 ou 38
 '********************************************************************
        LOCATE la%, 2: PRINT STRING$(70, " ")
END SUB
 '*********************************************************************
SUB calcv (d%, e%, f%, g%, h%, al%)
 ' dtermine la valeur de:  B%,  K% , V%
 ' entre:    B%, K%, V%, saut(dx%), saut(dx% + 1), saut(dx% + 2)
 ' Sortie:    B%, K%, V% actualiss
 '********************************************************************
    f% = cf%(g%, h%)            ' V%
    e% = z%(tf%(al%)) - (al% - 1)    ' K%
    d% = d% + 1                ' B%
END SUB
 '********************************************************************
FUNCTION calkoef% (bl%(), B%)
 ' calcul les coefficients [jf%]  appel par atrib pour les routines 
 '        test,    testT1,    testK1,    testK2
 ' entre :       bl%(), B%,
 ' Sortie  :      kf1% ( = jf%) dans la fonction calkoef%
 '********************************************************************
    kf1% = 0
    ' cas B% = 1
    IF B% = 1 THEN kf1% = bl%(B%)
    ' cas B% compris entre 2 et 4 OU entre 9 et 15 
    IF (B% > 1 AND B% < 5) OR (B% >= 9 AND B% <= 15) THEN
        FOR nx% = 1 TO B%
            kf1% = kf1% + bl%(nx%)
            ' si B% entre 9 et 15 racourcir la boucle
            IF (B% >= 9 AND B% <= 15) AND nx% = 4 THEN nx% = 8
        NEXT nx%
    ' cas B% compris entre 5 et 8 OU entre 16 et 18 
    ELSEIF (B% >= 5 AND B% < 9) OR (B% > 15) THEN
        FOR nx% = 5 TO B%
            kf1% = kf1% + bl%(nx%)
            ' si B% entre 16 et 18 racourcir la boucle
            IF (B% > 15) AND (nx% = 8) THEN nx% = 15
        NEXT nx%
    END IF
    calkoef% = kf1%
END FUNCTION
 '********************************************************************
SUB collect (cha1$, cha2$, cha3$, mir$())
 ' obtenir le catalogue des rpertoires et fichiers.
 '********************************************************************
    cmd$ = "command /c"
    SHELL _HIDE cmd$ + "dir " + cha1$ + " > " + cha2$    ' rpertoires ou fichiers
    nfich% = FREEFILE
    OPEN cha2$ FOR INPUT AS nfich%
    IF LOF(nfich%) > 0 THEN
        jk% = 0
        DO UNTIL EOF(nfich%)
            LINE INPUT #nfich%, ir$
            ir$ = LCASE$(ir$)
            cha3$ = LCASE$(cha3$)
            IF INSTR(ir$, cha3$) THEN
                jk% = jk% + 1
                IF INSTR(ir$, ".rbk") THEN
                    xtfich% = TRUE
                    mir$(jk%) = ir$
    '            ELSE
    '                xtdir% = TRUE
                END IF
            END IF
        LOOP
    END IF
    CLOSE #nfich%
    KILL cha2$
END SUB
 '********************************************************************
SUB chks
 ' Cheksum si les entres des facettes sont correctes
 ' On doit trouver 9 blanches, 9 vertes ... et 9 jaunes.
 '********************************************************************
    REDIM ctrl%(0 TO 6) 
    FOR op% = 1 TO nbfac%
        FOR om% = 1 TO nfacet%
            ' faire la somme des couleurs de facettes identiques
            ctrl%(C%(op%,om%)) = ctrl%(C%(op%,om%)) + C%(op%, om%)
        NEXT om%
    NEXT op%
    op1% = la%: op2% = la% + 5
    FOR op% = op1% TO op2%
        LOCATE op%, 2: PRINT STRING$(70, " ")
    NEXT op%
    dom% = op1%
    FOR op% = 1 TO nbfac%
        IF ctrl%(op%) <> co%(op%) * nfacet% THEN
            LOCATE dom%, 2 
            PRINT " vous avez entr"; ctrl%(op%)/co%(op%); " facettes "; nocou(op%).kol
            dom% = dom% + 1
        ELSE
            ctrl%(0) = ctrl%(0) + ctrl%(op%)
        END IF
    NEXT op%
    ' Si somme de contrle est correcte, alors tem% = 1
    IF ctrl%(0) = 189 THEN
        tem% = 1
        ERASE ctrl% ' rcuprer de la mmoire
    ELSE
        LOCATE CSRLIN, 2: PRINT " vous devez recommencer la saisie des couleurs des facettes "
        tem% = 0
        LOCATE CSRLIN, 2
        PRINT con$ 
        SLEEP
        CLS
    END IF
END SUB
 '********************************************************************
SUB delay
 ' delai indpendant de la vitesse du CPU.
 '  bas sur les ticks timer (18.2 fois par seconde) = 55ms
 ' en fonction de delier# exprim en Seconde.
 ' Si delier# = 0, pas d'excution de la routine.
 '********************************************************************
    IF delier# = 0 THEN EXIT SUB
    debut# = TIMER
    WHILE TIMER - debut# <= delier#
    WEND
    delier# = 0    ' remettre delier#  0
END SUB
 '********************************************************************
SUB dkolfac
 ' en entre:     Interface homme-machine.
 '                La facette cible est noire.
 ' en sortie:     Couleurs des 54 facettes en 6 groupes de 9.
 '                la facette 5 de chaque face est affecte d'office.
 '                Au dpart et par dfaut, les facettes sont grises.
 '********************************************************************
 ' Init donnes couleurs des facettes
    DO
        IF tem% = 0 THEN
            FOR i% = 1 TO nbfac%
                FOR j% = 1 TO nfacet%
                    C%(i%, j%) = P%(8)
                    ' couleur de la facette 5
                    IF j% = 5 THEN C%(i%, j%) = i%
                NEXT j%
            NEXT i%
            Affcub j%, gm$, tem%
        END IF
        tem% = 0
        ' Entre des donnes pour les 6 faces
        FOR i% = 1 TO nbfac%
            Affcol
            LOCATE 5, 2: PRINT "    Face"; i%,
            PRINT
            ' et pour les 9 facettes
            FOR j% = 1 TO nfacet%
                DO
                    LOCATE 7, 32: PRINT STRING$(4, " ")
                    ' si facette 5, ne rien faire
                    IF j% = 5 THEN EXIT DO
                    LOCATE 7, 2: PRINT " Couleur de la facette   : "; j%; " "
                    C%(i%, j%) = 0
                    Affcub j%, gm$, tem%
                    DO UNTIL (C%(i%, j%) <= 6) AND (C%(i%, j%) > 0)
                        C%(i%, j%) = VAL(INKEY$)
                    LOOP
                    Affcub j%, gm$, tem%
                    EXIT DO
                LOOP
            NEXT j%
            LOCATE la%, 2: PRINT " Valeurs correctes (O/N) :  ",
            lm$ = "" 
            lm$ = req$(lm$, "O", "N") 
            ' effacer le message
            effa52
            ' Si entres incorrectes
            IF lm$ = "N" THEN
                ' remettre les facettes couleur grise
                FOR j% = 1 TO nfacet%
                    C%(i%, j%) = P%(8)
                    ' couleur de la facette 5
                    IF j% = 5 THEN C%(i%, j%) = i%
                NEXT j%
                ' actualiser l'cran
                Affcub j%, gm$, tem%
                ' actualiser  i%
                i% = i% - 1
            END IF
        NEXT i%
        '  contrler si pas d'entres doubles
        ' si OK, le temoin tem% = 1
        chks
        IF tem% = 1 THEN Affect: EXIT DO
    LOOP
END SUB
 '********************************************************************
SUB exmov (exc%, gm$)
 ' routine partage d'excution des rotations
 '********************************************************************
    IF exc% < 3 THEN ko% = 3
    IF exc% > 2 AND exc% < 5 THEN ko% = 5
    IF exc% > 4 AND exc% < 7 THEN ko% = 1
    IF exc% > 6 AND exc% < 9 THEN ko% = 6
    IF exc% > 8 AND exc% < 11 THEN ko% = 2
    IF exc% > 10 AND exc% < 13 THEN ko% = 4
    SELECT CASE exc%
        CASE 1, 3, 5, 7, 9, 11
            sdlm Ko%, 3, 2, 1, 4, 7, 8, 9, 6
        CASE 2, 4, 6, 8, 10, 12
            sdlm Ko%, 1, 2, 3, 6, 9, 8, 7, 4
    END SELECT
    Translat exc%, L%, gm$
END SUB
 '********************************************************************
SUB failinit (vc%)
 ' Initialiser les tableaux C%() et tf%()
 ' vc% = valeur d'entre de config en fonction de hi% et/ou hf%
 '********************************************************************
    initC vc%
    initF vc%
END SUB
 '********************************************************************
SUB helpmov (g%, gm$)
 ' aide aux rotations manuelles et affichage des mouvements
 ' Le mot "arrire" est tronqu (pour mise en forme).
 '********************************************************************
    IF bd% = 0 OR g% > LEN(gm$) THEN EXIT SUB
    IF col% > 70 THEN      ' pour ajuster l'affichage
        lign% = lign% + 1 :col% = 2
        LOCATE lign%, col%
    END IF 
    DO
        IF g% > LEN(gm$) THEN PRINT "            "; : EXIT DO
        ' tenir compte d'un affichage pour L% >= 10
        IF L% < 10 THEN col% = col% + 1: LOCATE lign%, col%
        SELECT CASE bd%
            CASE 1, 3, 5, 7, 9, 11
                m% = &H2B ' signe +
            CASE 2, 4, 6, 8, 10, 12
                m% = &H2D ' signe -
        END SELECT
        IF bd% > 0 AND bd% < 3 THEN mc$ = "AVant  ": EXIT DO
        IF bd% > 2 AND bd% < 5 THEN mc$ = "ARiere ": EXIT DO
        IF bd% > 4 AND bd% < 7 THEN mc$ = "HAut   ": EXIT DO
        IF bd% > 6 AND bd% < 9 THEN mc$ = "BAs    ": EXIT DO
        IF bd% > 8 AND bd% < 11 THEN mc$ = "GAuche ": EXIT DO
        IF bd% > 10 AND bd% < 13 THEN mc$ = "DRoit  ": EXIT DO
    LOOP
    PRINT L%; mc$ + CHR$(m%);
END SUB
 '********************************************************************
SUB initC (y%)
 ' initialiser tableaux    C%() ou
 '             cf%() en fonction de la valeur y%
 '********************************************************************
    FOR i% = 1 TO nbfac%
        FOR j% = 1 TO nfacet%
            IF y% = 1 THEN cf%(i%, j%) = C%(i%, j%)
            IF y% = 2 THEN C%(i%, j%) = i%
            IF y% = 3 THEN C%(i%, j%) = w%(C%(i%, j%))
        NEXT j%
    NEXT i%
END SUB
 '********************************************************************
SUB initF (rl%)
 ' initialiser tableaux tf%()      ou t%() et z%()     ou z%()
 ' selon valeur de rl%
 '********************************************************************
    FOR gk% = 1 TO 20
        IF rl% = 1 THEN tf%(gk%) = t%(gk%)
        IF rl% = 2 THEN t%(gk%) = gk%: z%(gk%) = gk%
        IF rl% = 3 THEN z%(t%(gk%)) = gk%
    NEXT gk%
END SUB
 '********************************************************************
FUNCTION invert$ (miss AS STRING)
 ' Inversion du message
    DIM ml$
    ml$ = LEFT$(miss, 1) + MID$(miss, 4, 1) + MID$(miss, 3, 1) + MID$(miss, 2, 1)
    ml$ = ml$ + MID$(miss, 5, 1) + MID$(miss, 8, 1) + MID$(miss, 7, 1) + MID$(miss, 6, 1)
    invert$ = ml$
END FUNCTION
 '********************************************************************
SUB invrc (chifr$())
 ' Inversion de tr$(1  4)
 ' 1 vers 1
    chifr$(1) = LEFT$(tr$(1), 1) + RIGHT$(tr$(1),1) + MID$(tr$(1),3,1) + MID$(tr$(1),2,1)
 ' 2 vers 4 chi$ = savegarde tr$(2)
    chi$ = chifr$(2)
    chifr$(2) = LEFT$(tr$(4), 1) + RIGHT$(tr$(4),1) + MID$(tr$(4),3,1) + MID$(tr$(4),2,1)
 ' 3 vers 3
    chifr$(3) = LEFT$(tr$(3), 1) + RIGHT$(tr$(3),1) + MID$(tr$(3),3,1) + MID$(tr$(3),2,1)
 ' 4 vers 2
    chifr$(4) = LEFT$(chi$, 1) + RIGHT$(chi$,1) + MID$(chi$,3,1) + MID$(chi$,2,1)
END SUB
 '********************************************************************
FUNCTION mconfig% (cn$)
 ' choix utilisateur
 '********************************************************************
    SHARED hf%
    IF hf% = 0 THEN
        COLOR p%(7)
        boiteds 15, 1, cz% - 2, 37
        LOCATE 17, 2: PRINT "     Vous avez 2 choix  faire "
        LOCATE 18, 2: PRINT " Configuration ";
        COLOR p%(10): PRINT "FINALE";
        COLOR p%(7): PRINT " et   Configuration ";
        COLOR p%(10): PRINT "INITIALE."
        LOCATE 19, 2: PRINT
        COLOR p%(7): LOCATE 20, 2: PRINT " Configuration ";
        COLOR p%(10): PRINT "FINALE: "
        COLOR p%(7): LOCATE 21, 2: PRINT "  Choix '1': le cube sera en ordre  la fin. "
        LOCATE 22, 2: PRINT "  Choix '2': Vous faites la rotation des faces  votre guise "
        LOCATE 23, 2: PRINT
        LOCATE 24, 2: PRINT " Configuration ";
        COLOR p%(10): PRINT "INITIALE: "
        COLOR p%(7): LOCATE 25, 2: PRINT "  Si, pour Configuration ";
        COLOR p%(10): PRINT "FINALE";
        COLOR p%(7): PRINT ", Votre choix est '1', alors "
        LOCATE 26, 2: PRINT "  Il vous sera propos:  3. couleurs des facettes  votre choix. "
        LOCATE 27, 2: PRINT
        LOCATE 28, 2: COLOR p%(10): PRINT " FINALE = 1 et INITIALE = 2";
        COLOR p%(7): PRINT " ==> rotation des faces et rsolution du cube. "
        COLOR p%(10): LOCATE 29, 2: PRINT " FINALE = 2 et INITIALE = 2";
        COLOR p%(7): PRINT " ==> rotation des faces, pas de rsolution."
        COLOR p%(10): LOCATE 30, 2: PRINT " FINALE = 1 et INITIALE = 3";
        COLOR p%(7): PRINT " ==> rcuprer les donnes ou entrer les couleurs"
        LOCATE 31, 2: PRINT "       des facettes une  une.  ==> rsolution du cube."
        LOCATE 32, 2: PRINT
        COLOR p%(10): LOCATE 33, 2: PRINT " FINALE = 2 et INITIALE = 3";
        COLOR p%(7): PRINT " ==> rcuprer les donnes ou entrer les couleurs"
        LOCATE 34, 2: PRINT "        des facettes une  une. "
        LOCATE 35, 2: PRINT "   dans ce cas, ==> rotation des faces, pas de rsolution du cube."
    END IF
    Affcadr 10
    LOCATE 4, 2: PRINT " Configuration ";
    COLOR P%(10): PRINT cn$;
    COLOR P%(1): PRINT " dsire : "
    LOCATE 6, 3: PRINT "    1. Cube en ordre"
    LOCATE 7, 3: PRINT "    2. Cube obtenu par rotation des faces"
    IF hf% = 1 OR hf% = 2 THEN LOCATE 8,3: PRINT "    3. Couleurs des facettes  votre choix"
    loq% = CSRLIN
    IF hf% = 1 THEN
        LOCATE la% + 2, 4: PRINT " Choix '3': Vous rcuprez les donnes ou vous entrez "
        LOCATE la% + 3, 4: PRINT "            les couleurs de facettes une  une. "
    END IF
    COLOR p%(1): LOCATE loq%, 3: PRINT " Numro de votre choix : ";
    choi% = 0
    DO UNTIL (choi% > 0) AND (choi% <= 3)
        choi% = VAL(INKEY$)
    LOOP
    LOCATE CSRLIN, POS(0): PRINT LTRIM$(STR$(choi%))
    efface 1, la% + 2, la% + 3
    IF hf% = 1 THEN
        efface 1, la% + 2, la% + 3
    END IF
    mconfig% = choi%
    IF hf% <> 0 AND choi% <> 0 THEN efface 1, 15, 38
END FUNCTION
 '********************************************************************
SUB movself (zx%)
 ' Mouvements manuels (simulation)
 '********************************************************************
    efface 1, 1, 14
    IF zx% = 1 THEN lign% = CSRLIN: col% = POS(0)
    j% = 0
    DO
        efface 1, 1, 14
        COLOR P%(3)
        LOCATE 1, 22 : PRINT "   ***    Liste des commandes  ***"
        PRINT " "
        COLOR P%(7)
        LOCATE 3, 2: PRINT "  A - face avant ", "  P - face postrieure"
        LOCATE 4, 2: PRINT "  H - face haute", "  B - face basse"
        LOCATE 5, 2: PRINT "  G - face gauche", "  D - face droite"
        LOCATE 6, 2: PRINT "  Q - Quitter   (si 'Q' est seul, sinon ignor) "
        LOCATE 7, 2: PRINT "  Si lettre seule = sens montre , si '-' sens contraire"
        lq% = CSRLIN: pq% = POS(0)
        LOCATE la%, 2
        PRINT " Vous pouvez entrer plusieurs commandes (sans espace) "
        PRINT " Si cube en ordre, essayez:   AAPPHHBBDDGG      c'est remarquable! "
        PRINT "         refaites de mme, -->  Cube en ordre ! "
        LOCATE lq%, pq%
        COLOR P%(1)
        initF 3
        Affcub L%, gm$, tem%
        LOCATE 8, 2:INPUT " Commande : "; gm$
        gm$ = UCASE$(gm$)
        IF (LEN(gm$) = 1) AND (gm$ = "Q") THEN EXIT DO
        tem% = 1
        FOR L% = 1 TO LEN(gm$)
            r% = TRUE
            r$ = MID$(gm$, L%, 1)
            IF r$ = "-" THEN j% = j% + 1: L% = L% + 1: r$ = MID$(gm$, L%, 1)
            IF r$ = "A" THEN j% = j% + 1
            IF r$ = "P" THEN j% = j% + 3
            IF r$ = "H" THEN j% = j% + 5
            IF r$ = "B" THEN j% = j% + 7
            IF r$ = "G" THEN j% = j% + 9
            IF r$ = "D" THEN j% = j% + 11
            IF INSTR("APHBGD", r$) = 0 THEN
                L% = L% + 1
                r% = FALSE
            END IF
            IF r% THEN
                bd% = j%
                exmov j%, gm$
                j% = 0
            END IF
        NEXT L%
        initF 3
        Affcub L%, gm$, tem%
        Affect
    LOOP
    efface 1, la%, la% + 2
    Affect
END SUB
 '********************************************************************
SUB posit (rr%, us%, tu%)    'STATIC
 '  Routine de positionnement  l'cran
 '  des valeurs de B%,    K%,       V%
 '********************************************************************
    LOCATE 8, 3: PRINT "B:"; rr%, "K:"; us%, "V:"; tu%, "COMMANDES"
    COLOR P%(9)
    LOCATE 9, 2: PRINT STRING$(38, CHR$(223)); STRING$(42, " ")
    COLOR P%(1)
    LOCATE afli%, Afcol%
END SUB
 '********************************************************************
FUNCTION req$ (t$, rp1$, rp2$)
    DO UNTIL t$ = rp1$ OR t$ = rp2$
        t$ = UCASE$(INKEY$)
    LOOP
    req$ = t$
END FUNCTION
 '********************************************************************
SUB regles
    PCOPY 0, 1
    CLS
    Affcadr 2
    COLOR P%(7)
    LOCATE 6, 1
    PRINT TAB(6); "Quelques rgles pour rsoudre, et suivre les mouvements"
    PRINT TAB(8); "        du RUBIK'S CUBE  en mode PAS  PAS    "
    PRINT
    PRINT
    PRINT TAB(10); "1)    Le CUBE ne bouge pas !!!"
    PRINT
    PRINT TAB(10); "2)  Seules, les faces bougent !!!"
    PRINT
    PRINT TAB(15); "         ORIENTATION "
    PRINT TAB(10); "   Face 1 (BLANC) positionne vers le haut. "
    PRINT TAB(10); "   Face 2 (VERT) positionne  gauche. "
    PRINT TAB(10); "   Face 3 (ROUGE) positionne devant. "
    PRINT TAB(10); "   Face 4 (BLEU) positionne  droite. "
    PRINT TAB(10); "   Face 5 (ORANGE) positionne  l'arrire. "
    PRINT TAB(10); "   Face 6 (JAUNE) positionne vers le bas. "
    PRINT
    PRINT " Aprs quelques mouvements, le cube doit tre identique  l'image sur l'cran. "
    PRINT "      Si ce n'est pas le cas, vous vous tes tromp de sens (+ ou -). "
    PRINT
    PRINT " Prenez votre temps, je ne sais pas rsoudre le RUBIK's CUBE, mais le "
    PRINT " programme le fait aisment, de sorte que mon cube est toujours en ordre. "
    PRINT TAB(15); " Bonne Chance "
    PRINT
    PRINT con$
    SLEEP
    CLS
    PCOPY 1, 0
END SUB
 '********************************************************************
SUB rotax (gm$)
 ' Excute la commande place dans gm$: Rotation des faces
 '********************************************************************
    lign% = 10 :col% = 2
    COLOR P%(1)
    FOR L% = 1 TO LEN(gm$)
        bd% = ASC(MID$(gm$, L%, 1)) - 64
        exmov bd%, gm$
    NEXT L%
    IF L% > LEN(gm$) THEN
        delier# = 1.5:delay
        LOCATE afli%, Afcol%: PRINT STRING$(cz% - afcol%, " ")
        FOR gn% = 1 TO 5
            LOCATE afli% + gn%, 1: PRINT STRING$(cz% - 1, " ")
        NEXT gn%
        LOCATE lign%, col%
    END IF
    stat% = stat% + LEN(gm$)
    initF 3
END SUB
 '********************************************************************
SUB LirEcrir (xfich%, C%(), nz%)
 ' Lire depuis le disque ou crire vers le disque
 ' selon la valeur de nz%
 ' (nz%     = 1    lire.)    (nz%    = 2    crire.)
 '********************************************************************
    FOR i% = 1 TO nbfac%
        FOR j% = 1 TO nfacet%
            IF nz% = 1 THEN GET #xfich%, ,C%(i%, j%)
            IF nz% = 2 THEN PUT #xfich%, ,C%(i%, j%)
        NEXT j%
    NEXT i%
END SUB
 '********************************************************************
SUB Tablo (bor%, pfich%, br$(), ca$() )
 ' lire les gnrateurs depuis le disque
 '********************************************************************
    FOR i% = 1 TO bor%
        IF i% <= bor%/2 THEN 
            INPUT #pfich%, br$(i%)
        ELSE
            INPUT #pfich%, ca$(i% - bor%/2)
        END IF
    NEXT i%
END SUB
 '********************************************************************
SUB Tablau (bar%, kfich%, nd%(), na%())
 ' lire les Index depuis le disque
 '********************************************************************
    FOR i% = 1 TO bar%
        IF i% <= bar%/2 THEN
            GET #kfich%, ,nd%(i%)
        ELSE
            GET #kfich%, ,na%(i% - bar%/2)
        END IF
    NEXT i%
END SUB
 '********************************************************************
SUB Tablax (ber%, lfich%, ncu%())
 ' lire les Index depuis le disque
 '********************************************************************
    FOR i% = 1 TO ber%
        GET #lfich%, ,ncu%(i%)
    NEXT i%
END SUB
 '********************************************************************
SUB Tablat (bir%, ifich%, atu() AS bap, avu() AS sap, nt%)
 ' lire les Index de format TYPE depuis le disque
 '********************************************************************
    FOR i% = 1 TO bir%
        IF nt% = 1 THEN
            GET #ifich%, , atu(i%).tst1
            GET #ifich%, , atu(i%).tst2
        ELSE
            GET #ifich%, , avu(i%).tsk1
            GET #ifich%, , avu(i%).tsk2
            GET #ifich%, , avu(i%).tsk3
            GET #ifich%, , avu(i%).tsk4
        END IF
    NEXT i%
END SUB 
 '********************************************************************
SUB sdlm (kt%, s1%, s2%, s3%, s4%, s5%, s6%, s7%, s8%)
 ' Translation en fonction de la face du cube
 ' Sens montre ou inverse (en fonction des paramtres s1%  s8% transmis)
 ' En entre :
 '       kt% = identit de la face
 '       si s1%  s8% valent 3, 2, 1, 4, 7, 8, 9, 6 alors SENS de la MONTRE
 '       si s1%  s8% valent 1, 2, 3, 6, 9, 8, 7, 4 alors SENS INVERSE de la MONTRE
 ' En sortie:
 '       C%(kt%, sX%) translats en fonction du sens (sX% = de 1  8)
 '********************************************************************
    d1% = C%(kt%, s1%)
    d2% = C%(kt%, s2%)
    C%(kt%, s1%) = C%(kt%, s3%)
    C%(kt%, s2%) = C%(kt%, s4%)
    C%(kt%, s3%) = C%(kt%, s5%)
    C%(kt%, s4%) = C%(kt%, s6%)
    C%(kt%, s5%) = C%(kt%, s7%)
    C%(kt%, s6%) = C%(kt%, s8%)
    C%(kt%, s7%) = d1%
    C%(kt%, s8%) = d2%
END SUB
 '********************************************************************
SUB test (c1%, c2%, av%, af$, cma$)
 ' affichage du contenu de af$
 ' excution du contenu de cma$
 '********************************************************************
    IF (c1% > 0) AND (C%(c1%, c2%) = av%) THEN EXIT SUB
    COLOR P%(7)
    PRINT af$
    delier# = .5: delay
    rotax cma$
END SUB
 '********************************************************************
SUB testT1 (d1%, d2%, vb%, f1a$, f2a$, mca1$, mca2$)
 ' affichage des contenus de f1a$ OU f2a$
 ' excution des contenus de mca1$ OU mca2$
 '********************************************************************
    COLOR P%(7)
    IF C%(d1%, d2%) = vb% THEN
        PRINT f1a$
        delier# = .5: delay
        rotax mca1$
    ELSE
        PRINT f2a$
        delier# = .5: delay
        rotax mca2$
    END IF
END SUB
 '********************************************************************
SUB testK1 (a1%, a2%, a3%, a4%, va1%, af1$, af2$, ac1$, ac2$)
 ' affichage des contenus de    af1$ OU af2$
 ' excution des contenus de    ac1$ OU ac2$
 '********************************************************************
    IF C%(a1%, a2%) = va1% THEN EXIT SUB
    COLOR P%(7)
    IF C%(a3%, a4%) = va1% THEN
        PRINT af1$
        delier# = .5: delay
        rotax ac1$
    ELSE
        PRINT af2$
        delier# = .5: delay
        rotax ac2$
    END IF
END SUB
 '********************************************************************
SUB testK2 (b1%, b2%, b3%, b4%, va%, fa1$, fa2$, fa3$, ca1$, ca2$, ca3$)
 ' affichage des contenus de fa1$ OU fa2$ OU fa3$
 ' excution des contenus de ca1$ OU ca2$ OU ca3$
 '********************************************************************
    COLOR P%(7)
    IF C%(b1%, b2%) = va% THEN
        PRINT fa1$
        delier# = .5: delay
        rotax ca1$
    ELSEIF C%(b3%, b4%) = va% THEN
        PRINT fa2$
        delier# = .5: delay
        rotax ca2$
    ELSE
        PRINT fa3$
        delier# = .5: delay
        rotax ca3$
    END IF
END SUB
 '********************************************************************
SUB traceface (v1%, v2%, v3%, v4%, v5%, v6%)
 ' attribution des lments transmits v1%  v6% = face
 ' Les paramtres t1%  t13%  sont diffrents en fonction de la face
 ' t14% et t15% ne sont utiliss que pour la face  5
 '********************************************************************
    u0% = 0: u1% = CINT(30 * kfc): u2% = CINT(15 * kfc): u3% = CINT(Kfsn% * kfc)
    dt% = (u1% + spr%): du% = (u3% + spr%)
    dv% = (u2% + spr%)
    FOR v7% = 1 TO 6
        t4% = u0%: t5% = u2%: t6% = -u1%
        t7% = u0%: t8% = u3%: t9% = -u1%
        t10% = u1%: t11% = u0%: t13% = CINT(10 * kfc)
        IF v7% = 1 THEN
            t1% = v1%  ' V1% = face 1
            t2% = Kx1%: t3% = Ky1%
            t4% = -u3%: t9% = -u2%
            t12% = -CINT(15 * kfc)
        ELSEIF v7% = 2 THEN
            t1% = v2%  ' V2% =  face 3
            t2% = t2% - 2
            t3% = t3% + 1
            t5% = u1%: t8% = u0%
            t12% = -CINT(10 * kfc)
        ELSEIF v7% = 3 THEN
            t1% = v3%  ' V3% = face 4
            IF scrn% = 1 THEN
                t2% = t2% + ((2 * dt%) + du%) - spr% 
                t2% = t2% + 1
                t3% = t3% - (3 * dt%) - u3% - spr% - 1
                t3% = t3% - 1
            ELSE
                t2% = t2% + (2 * dt%) + du% - spr% + 1
                t3% = t3% - (3 * dt%) - u3% - spr% - 1
            END IF
            t5% = u1%: t6% = -u3%
            t7% = u2%: t8% = u0%
            t10% = u3%: t11% = -u2%
            t12% = -CINT(3 * kfc)
        ELSEIF v7% = 4 THEN
            t1% = v4%  ' V4% =  face 2
            ' position du curseur graphique en X (partie 2)
            ' position du curseur graphique en Y (partie 2)
            t2% = Kx2%: t3% = Ky2% - 1
            t5% = u1%: t8% = u0%
            t12% = -CINT(10 * kfc)
        ELSEIF v7% = 5 THEN
            t1% = v5%  ' V5% = face 5
            t2% = t2% - (2 * dt%) - spr%
            t3% = t3% - 2 * u1% - 1
            t4% = -u3%: t6% = u0%
            t7% = u1%: t9% = -u2%
            t10% = u0%: t11% = -u1%
            t12% = -CINT(4 * kfc) 
            t14% = t2%: t15% = t3%
        ELSEIF v7% = 6 THEN
            t1% = v6%  ' V6% =  face 6
            t2% = t2% + (3 * dt%) + (2 * spr%)
            t3% = t3% - (2 * dv%) - spr%
            t4% = -u3%: t6% = u1%
            t9% = -u2%: t10% = -u1%
            t12% = CINT(15 * kfc)
        END IF
        FOR i% = 0 TO 2
            ' I% part de 0 au lieu de 1, pour le calcul
            ' utilis dans PAINT ....P%(C%(t1%, (3 * i% + j%)))
            FOR j% = 1 TO 3
                ' fixe coordonnes x1, y1  trac relatif x1  dx, y1  dy
                LINE (t2%, t3%)-STEP(t4%, t5%), 7
                ' trac relatif x1 = x1  dx, y1 = y1   dy
                LINE -STEP(t6%, t7%), 7
                '  trac relatif x1 = x1  dx, y1 = y1  dy
                LINE -STEP(t8%, t9%), 7
                '  trac relatif x1 = x1  dx, y1 = y1  dy
                LINE -STEP(t10%, t11%), 7
                ' Colorer la facette, le pointeur doit tre  l'intrieur de la bordure ferme !
                PAINT STEP(t12%, t13%), P%(C%(t1%, (3 * i% + j%))), 7
                ' mettre  jour le(s) pointeur(s) graphique(s) pour le futur trac interne 
                ' la face concerne.
                ' EX: Dans la face (t1%) la procdure trace les facettes 1, 2 et 3
                IF t1% > 0 AND t1% < 4 THEN
                    t2% = t2% + dt%
                ELSEIF t1% = 4 THEN 
                    t2% = t2% + du% 
                    IF scrn% = 1 AND t1% = 4 AND t2% => 242 THEN t2% = t2% - 1
                    IF scrn% = 2 AND t1% = 4 AND t2% => 270 THEN t2% = t2% -2
                    t3% = t3% - dv% + 1
                ELSEIF t1% = 5 THEN 
                    t2% = t2% + du% 
                    t3% = t3% - dv% - 1
                ELSE
                    t2% = t2% - du%
                    t3% = t3% + dv%
                END IF
            NEXT j%
            ' mettre  jour les pointeurs graphiques en x et y pour le futur trac
            ' La procdure prpare le trac des facettes 4, 5 et 6 puis
            ' le trac des facettes  7, 8 et 9;  t1% = Nr face
            IF t1% = 1 THEN
                t2% = t2% - (3 * dt%) - u3% - 1
                t3% = t3% + dv%
            ELSEIF t1% = 2 OR t1% = 3 THEN
                t2% = t2% - (3 * dt%)
                t3% = t3% + dt% + 1
            ELSEIF t1% = 4 THEN
                    t2% = t2% - (3 * du%) 
                    t3% = t3% + (3 * (u1% - spr%))
                IF scrn% = 1 THEN
                    t2% = t2% + spr%
                    t3% = t3% - spr%
                ELSE
                    t2% = t2% + spr% + 1
                    t3% = t3% + 1
                END IF
            ELSEIF t1% = 5 THEN
                t2% = t14%
                t3% = t15% + dt% - 1
                t14% = t2%
                t15% = t3%
            ELSE
                t2% = t2% + du% + spr% 
                t3% = t3% - (3 * du%)
            END IF
        NEXT i%
    NEXT v7%
END SUB
 '********************************************************************
SUB Tri (am$())
 '  mettre les fichiers en ordre.
 '------------------------------------------------------------------------------
    DIM tbx$(16)
    SHARED mind%
    FOR i% = 1 TO mind%
        IF INSTR(am$(i%), ".") = 7 THEN
            xi% = VAL(MID$(am$(i%), 6, 1))
            tbx$(xi%) = am$(i%)
        ELSE
            xi% = VAL(MID$(am$(i%), 6, 2))
            tbx$(xi%) = am$(i%)
        END IF
    NEXT I%
    FOR I% = 1 TO mind%
        am$(i%) = tbx$(I%)
    NEXT i%
    ERASE tbx$
END SUB
 '********************************************************************
SUB Translat (mx%, lz%, ll$)    'STATIC
 ' Effectue la translation des cubes lmentaires aprs la rotation des faces
 ' Utilisation des variables bt%, bu%, bv%, bw% de valeur respectives 1, 2, 3 et 4
 '********************************************************************
    DIM R.Ms AS STRING * 8
    SELECT CASE mx%
        CASE 1, 2
'   Rotation Face AV SENS MONTRE
            tr$(1) = "1987"
            tr$(2) = "2369"
            tr$(3) = "6123"
            tr$(4) = "4741"
            R.Ms = "AEHDPLMT"
'   Rotation Face AV SENS INVERSE MONTRE
            IF mx% = 2 THEN invrc tr$(): R.Ms = invert$(R.Ms) ' = "ADHEPTML"
        CASE 3, 4
'   Rotation Face AR SENS MONTRE
            tr$(1) = "1123"
            tr$(2) = "4369"
            tr$(3) = "6987"
            tr$(4) = "2741"
            R.Ms = "BCGFJORN"
'   Rotation Face AR SENS INVERSE MONTRE
            IF mx% = 4 THEN invrc tr$(): R.Ms = invert$(R.Ms) ' = "BFGCJNRO"
        CASE 5, 6
'   Rotation Face HAute SENS MONTRE
            tr$(1) = "3123"
            tr$(2) = "4123"
            tr$(3) = "5123"
            tr$(4) = "2123"
            R.Ms = "ADCBILKJ"
'   Rotation Face HAute SENS INVERSE MONTRE
            IF mx% = 6 THEN invrc tr$(): R.Ms = invert$(R.Ms) ' = "ABCDIJKL"
        CASE 7, 8
'   Rotation Face BAsse SENS MONTRE
            tr$(1) = "3987"
            tr$(2) = "2987"
            tr$(3) = "5987"
            tr$(4) = "4987"
            R.Ms = "EFGHQRST"
'   Rotation Face BAsse SENS INVERSE MONTRE
            IF mx% = 8 THEN invrc tr$(): R.Ms = invert$(R.Ms) ' = "EHGFQTSR"
        CASE 9, 10
'   Rotation Face GAuche SENS MONTRE
            tr$(1) = "1741"
            tr$(2) = "5369"
            tr$(3) = "6741"
            tr$(4) = "3741"
            R.Ms = "ABFEINQM"
'   Rotation Face GAuche SENS INVERSE MONTRE
            IF mx% = 10 THEN invrc tr$(): R.Ms = invert$(R.Ms) ' = "AEFBIMQN"
        CASE 11, 12
'   Rotation Face DRoite SENS MONTRE
            tr$(1) = "1369"
            tr$(2) = "3369"
            tr$(3) = "6369"
            tr$(4) = "5741"
            R.Ms = "DHGCKPSO"
'   Rotation Face DRoite SENS INVERSE MONTRE
            IF mx% = 12 THEN invrc tr$(): R.Ms = invert$(R.Ms) ' = "DCGHKOSP"
    END SELECT
    REDIM ma%(4), kf%(4, 3), e%(8)
    FOR ix% = 1 TO 4
        ma%(ix%)    = VAL(LEFT$(tr$(ix%), 1))
        kf%(ix%, bt%)    = VAL(MID$(tr$(ix%), 2, 1))
        kf%(ix%, bu%)    = VAL(MID$(tr$(ix%), 3, 1))
        kf%(ix%, bv%)    = VAL(RIGHT$(tr$(ix%), 1))
    NEXT ix%
    d1% = C%(ma%(bt%), kf%(bt%, bt%))
    d2% = C%(ma%(bt%), kf%(bt%, bu%))
    d3% = C%(ma%(bt%), kf%(bt%, bv%))
    C%(ma%(bt%), kf%(bt%, bt%))    = C%(ma%(bu%), kf%(bu%, bt%))
    C%(ma%(bt%), kf%(bt%, bu%))    = C%(ma%(bu%), kf%(bu%, bu%))
    C%(ma%(bt%), kf%(bt%, bv%))    = C%(ma%(bu%), kf%(bu%, bv%))
    C%(ma%(bu%), kf%(bu%, bt%))    = C%(ma%(bv%), kf%(bv%, bt%))
    C%(ma%(bu%), kf%(bu%, bu%))    = C%(ma%(bv%), kf%(bv%, bu%))
    C%(ma%(bu%), kf%(bu%, bv%))    = C%(ma%(bv%), kf%(bv%, bv%))
    C%(ma%(bv%), kf%(bv%, bt%))    = C%(ma%(bw%), kf%(bw%, bt%))
    C%(ma%(bv%), kf%(bv%, bu%))    = C%(ma%(bw%), kf%(bw%, bu%))
    C%(ma%(bv%), kf%(bv%, bv%))    = C%(ma%(bw%), kf%(bw%, bv%))
    C%(ma%(bw%), kf%(bw%, bt%))    = d1%
    C%(ma%(bw%), kf%(bw%, bu%))    = d2%
    C%(ma%(bw%), kf%(bw%, bv%))    = d3%
    FOR y% = 1 TO LEN(R.Ms)
        e%(y%) = ASC(MID$(R.Ms, y%, 1)) - 64
    NEXT y%
    FOR y% = 1 TO UBOUND(e%)
        IF y% = 1 THEN it% = t%(e%(y%))
        IF y% < 4 THEN t%(e%(y%)) = t%(e%(y% + 1))
        IF y% = 4 THEN t%(e%(y%)) = it%
        IF y% = 5 THEN it% = t%(e%(y%))
        IF (y% >= 5) AND (y% < 8) THEN t%(e%(y%)) = t%(e%(y% + 1))
        IF y% = 8 THEN t%(e%(y%)) = it%
    NEXT y%
    Affcub lz%, ll$, tem%
END SUB
'******************************************************************************
' Fin de fichier "CUB641BF.bas"
